Message - Id: $GW3TMH000191
Msg Type: B$
Date: 15 Jan 97 8:20:36
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (33)

R:970115/0820z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/address
 *
 */

/******************************************************************************/
/*                                                                            */
/*                                 address.c                                  */
/*                                                                            */
/*  This looks up the full heirachical address for a user, the user enters    */
/*  as much as possible on the command line, for example  ADDRESS J           */
/*  will look up all the mailboxes with the prefix of  J  ADDRESS JA          */
/*  will look up all the mailboxes with the prefix of JA                      */
/*                                                                            */
/******************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

void error(void);
void page(void);

int pg;
int ln;

void main(int argc, char *argv[])
{
char filename[35] = "/ax25/mbx/home_files/mailbox.?";
char test[7];
int count = 0;
int flag = 0;
int a;
int i;

char str1[9];
char str2[70];
char str3[9];

FILE *fp;

pg = 0;
ln = 0;

if (argc == 1) error(); /* Nothing entered */
if (argc > 2 ) error(); /* Too many parameters entered */
if (strlen(argv[1]) > 6) error(); /* Find callsign is too long */

/*
 * Open user data base, to see if paging is required
 */

sprintf(str2,"/ax25/mbx/system_files/%s.data",argv[0]);

if ((fp = fopen(str2,"r")) != NULL)
   {
   fseek(fp,117,SEEK_SET);
   fscanf(fp,"%s %s",str1,str3);
   fclose(fp);
   str3[0] = str3[4];
   str3[1] = str3[5];
   str3[2] = 0;
   pg = atoi(str3);
   }

/*
 * Now get the string we are going to test for and make it upper case
 */

strcpy(test,argv[1]);
i = strlen(test);

for (a = 0; a < i; a++) test[a] = toupper(test[a]);

/*
 * Use first character in search name to decide which file to search
 */

filename[28] = test[0];

if ((fp = fopen(filename,"r")) != NULL)
   {
   while(fscanf(fp,"%s %s %s",str1,str2,str3) != EOF)
      {
      for (a = 0; a < i; a++)
         {
         if (test[a] == str1[a]) flag = 1;

         else
            {
            flag = 0;
            break;
            }
         }

/*
 * If we get this far and flag is high we have a match
 */

      if (flag)
         {
         count++;
         flag = 0;
         printf("On %c%c-%c%c-19%c%c %s.%s\n",
         str3[4],str3[5],str3[2],str3[3],str3[0],str3[1],str1,str2);
         if (pg) page();
         }
      }
   fclose(fp);
   }

if (!count)
   {
   printf("%s unknown.\n",test);
   }
}

/*----------------------------------------------------------------------------*/

void error(void)
{
printf("Usage: ADDRESS callsign\n");
exit(0);
}

/*----------------------------------------------------------------------------*/

void page(void)
{
char temp[81];
int i;

ln++;
if (ln == pg)
   {
   ln = 0;
   printf("\nMore (A) > "); 
   for (i = 0; i < 80; i++)
      {
      temp[i] = getchar();
      if (temp[i] == '\n') break;
      }
   temp[i] = 0;
   if (!strcmp(temp,"a")) exit(0);
   }
}

/*----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

