Message - Id: $GW3TMH000089
Msg Type: B$
Date: 13 Dec 96 10:54:39
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (04)

R:961213/1054z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * First make the directory tree  /ax25/mbx/system_files
 * Then compile and run this utility to build the indexes to
 * the 10,000 messages that this mailbox is designed to handle.
 *
 */

/******************************************************************************/
/*                                                                            */
/*                                 bbsmkfil.c                                 */
/*                                                                            */
/*            This is used to build the mail header and index files           */
/*                                                                            */
/******************************************************************************/

#include <stdio.h>
#include <fcntl.h>

main()
{
register int f;
char string[81];
FILE *fp;
int i;

umask(0111);

/*
 * First create "last.msg" this is used to generate the message numbers.
 *
 * Before it is read from, it must be locked, to prevent two users from
 * generating the same message number.
 */
if ((fp = fopen("/ax25/mbx/system_files/last.msg","w")) != NULL)
   {
   fprintf(fp,"0\n");
   fclose(fp);
   }


/* Next create "last.mid" used to update the mid/bid file */
if ((fp = fopen("/ax25/mbx/system_files/last.mid","w")) != NULL)
   {
   fprintf(fp,"0\n");
   fclose(fp);
   }

/* Then create the mids/bids file with room for 999 mids/bids */
if ((fp = fopen("/ax25/mbx/system_files/mids","w")) != NULL)
   {
   for (i = 1; i <= 999; i++)
      {
      fprintf(fp,"$ABC123456789\n");
      }
   fclose(fp);
   }

/*
 * Now create the mail header file for 9,999 messages.
 */
if ((fp = fopen("/ax25/mbx/system_files/header","w")) != NULL)
   {
   for (i = 1; i <= 9999; i++)
      {
      fprintf(fp," %04d  B$  1234 GW3TMH GB7ABC GB7ABC 1234/5678 ",i);
      fprintf(fp,"Now is the time for all good. \n");
      }
   fclose(fp);
   }

/*
 * Finally create the three "index" files, these are used to speed up
 * any searches.
 */


/* Used by the   L> G9ABC   command */
if ((fp = fopen("/ax25/mbx/system_files/to","w")) != NULL)
   {
   for (i = 1; i <= 9999; i++)
      {
      fprintf(fp,"------\n");
      }
   fclose(fp);
   }


/* Used by the   L< G9ABC   command */
if ((fp = fopen("/ax25/mbx/system_files/from","w")) != NULL)
   {
   for (i = 1; i <= 9999; i++)
      {
      fprintf(fp,"------\n");
      }
   fclose(fp);
   }


/* Used by the   L@ G9ABC   command */
if ((fp = fopen("/ax25/mbx/system_files/at","w")) != NULL)
   {
   for (i = 1; i <= 9999; i++)
      {
      fprintf(fp,"------\n");
      }
   fclose(fp);
   }

for (i = 'A'; i <= 'Z'; i++)
   {
   sprintf(string,"/ax25/mbx/home_files/home_%c_.bbs",i);
   f = creat(string, 0666);
   close(f);
   sprintf(string,"/ax25/mbx/home_files/mailbox.%c",i);
   f = creat(string, 0666);
   close(f);
   }
}

/*----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

