Message - Id: $GW3TMH000174
Msg Type: B$
Date: 8 Jan 97 9:11:11
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (25)

R:970108/0911z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/finger
 *
 */

/******************************************************************************/
/*                                                                            */
/*                                    f.c                                     */
/*                                                                            */
/*    This looks up all the info on a user, and presents it to the caller     */
/*                                                                            */
/******************************************************************************/

/* Date: is the date a person last connected                                  */
/* Time: is the time a person last connected                                  */
/* Sent: is the number of messages a person has sent                          */
/* Read: is the number of messages a person has read                          */
/* List: is the number of the last message listed                             */
/* Call: is the number of times a person has connected                        */
/* Mail: is the number of personal messages for the caller                    */
/* Srep: is used by the  SR  command                                          */

#include <sys/types.h>
#include <dirent.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

void finger(char *);
void error(void);

void main(int argc, char *argv[])
{
int a;
int b;
char filename[25];

DIR *dirp;
struct dirent *dp;

if (argc == 2)
   {
   if (strlen(argv[1]) < 7) finger(argv[1]);
   else error();
   }

if (argc > 2) error();

dirp = opendir("/ax25/mbx/system_files");

a = 0;

while((dp = readdir(dirp)) != NULL)
   {
   if (strstr(dp->d_name,".data"))
      {
      sprintf(filename,"%s",dp->d_name);

      for (b = 0; b <= 12; b++)
         if (filename[b] == '.')
            filename[b] = 0;

      printf("%-6s ",filename);

      a++;
      if (a > 9)
         {
         a = 0;
         printf("\n");
         }
      }
   }
closedir(dirp);
if (a) printf("\n");
}

void finger(string)
char string[8];
{
char filename[81];
char Temp[12];
char Buff[12];
long L;

FILE *fp;

sprintf(filename,"/ax25/mbx/system_files/%s.data",string);

if ((fp = fopen(filename,"r")) != NULL)
   {
   printf("Database entry for %s.\n",string);
   fscanf(fp,"%s %s",Temp,Buff);
   printf("Date last connected = %c%c-%c%c-19%c%c.\n",
   Buff[4],Buff[5],Buff[2],Buff[3],Buff[0],Buff[1]);
   fscanf(fp,"%s %s",Temp,Buff);
   printf("Time of last connection = %c%c:%c%c:%c%c.\n",
   Buff[0],Buff[1],Buff[2],Buff[3],Buff[4],Buff[5]);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Messages sent = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Messages Received = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Messages Read = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Last Listed = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Times connected = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Personal messages waiting = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   L = atol(Buff);
   printf("Last Message read = %ld.\n",L);
   fscanf(fp,"%s %s",Temp,Buff);
   if (Buff[0] == 'X') printf("Status is Expert.\n");
   Buff[0] = Buff[4];
   Buff[1] = Buff[5];
   Buff[2] = 0;
   L = atol(Buff);
   printf("Paging set at %ld lines.\n",L);
   fclose(fp);
   exit(0);
   }

else
   {
   printf("%s is not in database.\n",string);
   exit(0);
   }
}

/*----------------------------------------------------------------------------*/

void error(void)
{
printf("Invalid Command.\n");
exit(0);
}

/*-----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

