Message - Id: $GW3TMH000267
Msg Type: B$
Date: 1 Feb 97 8:59:37
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (50)

R:970201/0859z @:GB7ABC.#51.GBR.EU

forward.c part 2 of 4



                      fprintf(stderr, "forward: window must be between 1 and 7 frames\n");
                      end_prog();
                      }
                   }

                 break;

      case '?':
      case ':':
                 fprintf(stderr, "usage: forward [-b 1|e] [-d] [-m s|e] [-n] [-p port] [-w window] callsign [[via] digipeaters...]\n");
                 end_prog();
      }
   }

if (optind == argc)
   {
   fprintf(stderr, "usage: forward [-b 1|e] [-d] [-m s|e] [-n] [-p port] [-w window] callsign [[via] digipeaters...]\n");
   end_prog();
   }

if (netrom_setting)
   {
   if (nr_config_load_ports() == -1)
      {
      fprintf(stderr, "forward: no NET/ROM port data configured\n");
      end_prog();
      }

   if (port_setting < 0 || port_setting >= nr_config_num_ports())
      {
      fprintf(stderr, "forward: invalid port setting\n");
      end_prog();
      }

   paclen = nr_config_get_paclen(port_setting);
   }

else
   {
   if (ax25_config_load_ports() == -1)
      {
      fprintf(stderr, "forward: no AX.25 port data configured\n");
      end_prog();
      }

   if (port_setting < 0 || port_setting >= ax25_config_num_ports())
      {
      fprintf(stderr, "forward: invalid port setting\n");
      end_prog();
      }

   paclen = ax25_config_get_paclen(port_setting);
   }


/*
 * This is where the real forwarding work starts.
 */
                  


/*
 * Clear carrier detect flag.
 */
data_carrier_detect = FALSE;
line_number = 0;

sprintf(callsign,"%s",argv[optind]);

for(;;)
   {
   msg_number = anything_for(argv[optind]);

   if(data_carrier_detect)
      {
      /* We are connected */
      
      if (msg_number)
         {
         /* We have something to send */
         send_msg(msg_number); 
         }

      else
         {
         /* Nothing to send, see if we can remove forwarding file */
         sprintf(filename,"/ax25/mbx/system_files/%s.fwd",argv[optind]);
         unlink(filename);
         
         if (polling_flag)
            {
            /* Poll */
            }
         end_prog();  
         } 
      }

   else
      {
      /* We are not yet connected */

      if (msg_number)
         {
         /* We have something to send, better connect */
         data_carrier_detect = try_to_connect(argv[optind]);
         if (data_carrier_detect == FALSE) end_prog(); /* Failed to connect */
         if (get_prompt() == FALSE) end_prog();
         send_sid();
         if (get_prompt() == FALSE) end_prog();
         send_msg(msg_number);
         }

      else
         {
         /* We have nothing to send anyway, unless polling is set */
         end_prog();
         if (polling_flag)
            {
            /* Connect */
            }  

         else
            {
            /* Abort */
            }
         }
      }
   }
}

/*----------------------------------------------------------------------------*/

void convert_cr_lf(char *buf, int len)
{
while (len--)
   {
   if (*buf == '\r') *buf = '\n';
   buf++;
   }
}

/*----------------------------------------------------------------------------*/

void convert_lf_cr(char *buf, int len)
{
while (len--)
   {
   if (*buf == '\n') *buf = '\r';
   buf++;
   }
}

/*----------------------------------------------------------------------------*/

int try_to_connect(char call[20])
{
char string1[20], string2[20];
int i, result;
FILE *fp;

result = FALSE;

if ((fp = fopen("/ax25/mbx/system_files/connect_script","r")) != NULL)
   {
   for (i = 0; i <= 99; i++)
      {
      if (fscanf(fp,"%s %s",string1,string2) == EOF) break;
       
      if (result)
         {
         if (string1[0] == 'm') break;                         /* End connect */
         if (string1[0] == 'd') result = check_day(string2);   /* Check day   */
         if (string1[0] == 't') result = check_time(string2);  /* Check time  */
         if (string1[0] == 's') result = check_size(string2);  /* Check size  */
         if (string1[0] == 'c') result = do_connect(string2);  /* Try connect */
         }
      if ((string1[0] == 'm') && (!strcmp(call,string2))) result = TRUE;
      }
   fclose(fp);
   }
return result;
}

/*----------------------------------------------------------------------------*/

int check_day(char call[20])
{
return TRUE;
}

/*----------------------------------------------------------------------------*/

int check_time(char call[20])
{
return TRUE;
}

/*----------------------------------------------------------------------------*/

int check_size(char call[20])
{
return TRUE;
}

/*----------------------------------------------------------------------------*/

int do_connect(char *call)
{
int bytes;
char buf[512];

if (my_dcd)
   {
   sprintf(buf, "C %s\n",call);

   bytes = strlen(buf);

   convert_lf_cr(buf, bytes);

   if (write(fd, buf, bytes) == -1)
      {
      perror("write");
      end_prog();
      }

   while((bytes = read(fd, buf, 511)) > 0)
      {
      convert_cr_lf(buf, bytes);



from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

