Message - Id: $GW3TMH000135
Msg Type: B$
Date: 29 Dec 96 8:37:56
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (15)

R:961229/0837z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/ll
 *
 */

/******************************************************************************/
/*                                                                            */
/*                                    ll.c                                    */
/*                                                                            */
/*                  This is used to list the last n messages                  */
/*                                                                            */
/* A user can enter anything from  LL 1   to  LL 9999   to list the last msgs */
/*                                                                            */
/******************************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <pwd.h>

void sig_ser(int);
void error(int);
void page(void);

int pg;
int ln;
int mn;

/*----------------------------------------------------------------------------*/

void
sig_ser(int i)
{
lockf(mn,F_ULOCK,0);
close(mn);
exit(0);
}

/*----------------------------------------------------------------------------*/

void main(int argc, char *argv[])
{
char Temp[12], buffer[81];
int mn1, mn2, i;
long L;
FILE *fp;

pg = 0;
ln = 0;

if (argc == 1) error(0);   /* No number entered so send Usage */
if (argc > 2) error(1);    /* Bad number entered */
if (strlen(argv[1]) > 4) error(1);

/*
* See if the number entered is really a digit
*/
L = atol(argv[1]);
if (!L) error(1);

/*
 * Get the Page: parameter from the user data base
 */
sprintf(buffer,"/ax25/mbx/system_files/%s.data",argv[0]);

if ((fp = fopen(buffer,"r")) != NULL)
   {
   fseek(fp,117,SEEK_SET);
   fscanf(fp,"%s %s",buffer,Temp);
   fclose(fp);
   Temp[0] = Temp[4];
   Temp[1] = Temp[5];
   Temp[2] = 0;
   pg = atoi(Temp);
   }

/*
 * Get the number of the last message entered
 */
mn = open("/ax25/mbx/system_files/last.msg",O_RDONLY);
lockf(mn,F_LOCK,0);
signal(SIGHUP,sig_ser);
read(mn,Temp,9);
lockf(mn,F_ULOCK,0);
signal(SIGHUP,SIG_DFL);
close(mn);
mn1 = atoi(Temp);
mn2 = mn1;

/*
 * Now count backwards by the number entered on the command line
 */
for (i = 1; i < L; i++)
   {
   mn1--;
   if (mn1 == 0) mn1 = 9999;
   }

/*
 * List the header file from the number indicated, using paging if required
 */
if ((fp = fopen("/ax25/mbx/system_files/header","r")) != NULL)
   {
   fputs(" Msg#  TS  Size   To    From   @BBS  Date/Time I---------",stdout);
   fputs(" Subject. ---------I\n",stdout);

   if (pg) page();

   L = mn1;
   L--;
   L *= 78;

   fseek(fp,L,SEEK_SET);

   while(mn1 != mn2)
      {
      fgets(buffer,80,fp);
      fputs(buffer,stdout);
      if (pg) page();
      mn1++;
      /* If we reach the end of the header (msg 9999) wrap round to msg 1 */
      if (mn1 > 9999)
         {
         mn1 = 1;
         rewind(fp);
         }
      }
   fgets(buffer,80,fp);
   fputs(buffer,stdout);
   if (pg) page();
   fclose(fp);

   /* Now update our personal database */

   sprintf(buffer,"/ax25/mbx/system_files/%s.data",argv[0]);

   if ((fp = fopen(buffer,"r+")) != NULL)
      {
      fseek(fp,65,SEEK_SET);
      fprintf(fp,"List: %06d\n",mn2);
      fclose(fp);
      }
   }
}

/*---------------------------------------------------------------------------*/

void error(a)
int a;
{
if (!a) fputs("Usage: LL number\n",stdout);
else fputs("Bad number.\n",stdout);
exit(0);
}

/*----------------------------------------------------------------------------*/

/* If pager is required this will stop the listing, and see if the user want  */
/* more data, a user can enter  A  and abort the listing                      */

void page(void)
{
char temp[81];    /* This could be much smaller, but some users enter garbage */
int i;

ln++;
if (ln == pg)
   {
   ln = 0;
   fputs("\nMore (A) > ",stdout);
   for (i = 0; i < 80; i++)
      {
      temp[i] = getchar();
      if (temp[i] == '\n') break;
      }
   temp[i] = 0;
   if (!strcmp(temp,"a")) exit(0);
   }
}

/*----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

