Message - Id: $GW3TMH000094
Msg Type: B$
Date: 16 Dec 96 10:45:14
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (07)

R:961216/1045z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location...   /bin/ax25_shell
 *
 */

/******************************************************************************/
/*                                                                            */
/*                             ax25_shell.c                                   */
/*                                                                            */
/* This is the simple mailbox shell, it converts all commands into            */
/* lower case, adopts the identity of "root" then executes programs that      */
/* are in the mailbox directory.                                              */
/*                                                                            */
/* It sends the prompt of  "Unix ->"  to a caller, which switches to a longer */
/* string indicating the number of personal messages waiting to be read       */
/* ie  "You have 3 msg(s). >"  if there is mail waiting for a user.           */
/*                                                                            */
/* This shell will be called by "axspawn"                                     */
/*                                                                            */
/* This function executes programs in  /ax25/mbx/exec_files     directory     */
/*                                                                            */
/* To prove things are now working, I suggest you link a command into this    */
/* try   ln /bin/cal /ax25/mbx/exec_files/cal                                 */
/* a packet caller will now be allowed to use the command 'cal'               */
/*                                                                            */
/* To save a small amount of time, the callsign of the caller is passed to    */
/* programs called by this shell, in argv[0] this saves each program having   */
/* to look it up, any programs you run via this shell, such as games, should  */
/* be modified to allow for this if they need to know the caller, for example */
/* I have modified the save feature in my adventure games, so that when a     */
/* person saves the game, it re-names the save file as... world.save.callsign */
/*                                                                            */
/* Use  chmod a=sx ax25_shell  after compiling                                */
/*                                                                            */    
/******************************************************************************/

#include <pwd.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/ax25.h>

void parent(void);
int child(char *);

char callsign[10];

int main(void)
{
FILE *fp;

char filename[81];
char buffer[81];
char Temp[25];
char Mail[9];
int ruid;
int d;
int i;

struct passwd *pstp;

ruid = getuid();
if ((pstp = getpwuid(ruid)) == NULL) exit(0);

sprintf(callsign,"%s",pstp->pw_name);


/* If you have don't have a fortune cookie program comment this out. */
if (fork()) parent();
else child(".FORTUNE");


if (fork()) parent();
else child(".WELCOME");

/*
* Get the identity of the caller
*/
sprintf(filename,"/ax25/mbx/system_files/%s.data",callsign);

for(;;)
   {
   /* See if any mail is held for the caller */
   if ((fp = fopen(filename,"r")) == NULL) exit(1);
   fseek(fp,91,SEEK_SET);
   fscanf(fp,"%s %s",Temp,Mail);
   fclose(fp);

   /* If caller has mail, tell him, otherwise send normal prompt */
   if (strcmp(Mail,"000000"))
      {
      d = atoi(Mail);
      printf("\nYou have %d msg(s). > ",d);
      }

   else printf("\nUnix -> ");                     /* Send Prompt */

   /* Clear buffers */
   fflush(stdout);
   for (i = 0; i < 80; i++)
      buffer[i] = 0;

   /* Get a line of text and convert it to lower case */
   for (i = 0; i < 79; i++)
      {
      buffer[i] = getchar();
      buffer[i] = tolower(buffer[i]);
      if (buffer[i] == '\n') break;
      }
   buffer[i] = 0;

   if (i)
      {
      if (buffer[0] == 'b') exit(0);  
      /* Fork to execute the line entered as a command */
      if (fork()) parent();
      else child(buffer);
      }
   }
}

/*----------------------------------------------------------------------------*/

void parent()
{
wait(0);
}

/*----------------------------------------------------------------------------*/

int child(buffer)
char buffer[81];
{
char temp[81];
char str[4] [81];
int a, b, i;

FILE *fp;

a = 0;

for (i = 0; i <= 3; i++)
   {
   /* break the line entered into seperate strings, broken at space */
   str[i] [0] = 0;
   /* Swallow up any leading spaces */
   while(buffer[a] == ' ') a++;

   for (b = 0; b < 79; b++)
      {
      /* build buffer into str array */
      str[i] [b] = buffer[a];
      if (buffer[a] == 0) break;
      if (str[i] [b] == ' ') break;
      a++;
      }
   str[i] [b] = 0;
   }
/* Copy command into temp, forcing it to use  /ax25/mbx/exec_files */
sprintf(temp,"/ax25/mbx/exec_files/%s",str[0]);

/* Find out how many parameters we have to pass on */
for (i = 0; i <= 3; i++)
   if (str[i] [0] == 0)
      break;

i--;

/* Execute program if it is found */
switch(i)
   {
   case 0: execl(temp,callsign,NULL); break;
   case 1: execl(temp,callsign,str[1],NULL); break;
   case 2: execl(temp,callsign,str[1],str[2],NULL); break;
   case 3: execl(temp,callsign,str[1],str[2],str[3],NULL); break;
   }

printf("Invalid Command.\n");

/* See if we are expert, if we are return, otherwise send help */
sprintf(temp,"/ax25/mbx/system_files/%s.data",callsign);
if ((fp = fopen(temp,"r")) == NULL) exit(0);
fseek(fp,117,SEEK_SET);
fscanf(fp,"%s %s",str[0],temp);
fclose(fp);
if (temp[0] == 'X') exit(0);

execl("/ax25/mbx/exec_files/help",callsign,"all",NULL);
exit(0);
}

/*----------------------------------------------------------------------------*/




from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

