Message - Id: $GW3TMH000083
Msg Type: B$
Date: 12 Dec 96 12:11:06
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (03)

R:961212/1211z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location is...  /ax25/mbx/exec_files/.WELCOME
 *
 */

/*----------------------------------------------------------------------------*/
/*                                                                            */
/*                                  welcome.c                                 */
/*                                                                            */
/*                           This welcomes a caller                           */
/*                                                                            */
/* It looks for a file called user.data, where user is the callsign of        */
/* the person who has connected, this gives information used for the greeting */
/* text.                                                                      */
/*                                                                            */
/* Date: is the date a person last connected                                  */
/* Time: is the time a person last connected                                  */
/* Sent: is the number of messages a person has sent                          */
/* Read: is the number of messages a person has read                          */
/* List: is the number of the last message listed                             */
/* Call: is the number of times a person has connected                        */
/* Mail: is the number of personal messages for the caller                    */
/* Srep: is used by the  SR  command                                          */
/* Page: is used for setting the lines per page                               */
/*                                                                            */
/* A user will be greeted with a welcome message when they                    */
/* connect, but please note that the first time a user connects they are not  */
/* greeted, as the data base does not exist.                                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/

#include <time.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

void sig_ser(int);

int mn;

/*----------------------------------------------------------------------------*/

void
sig_ser(int i)
{
lockf(mn,F_ULOCK,0);
close(mn);
exit(0);
}

/*----------------------------------------------------------------------------*/

void main(int argc, char *argv[])
{
int last;
char filename[81], Temp[12], Date[9], Time[9], List[9], Call[9];
struct tm *tmnow;
time_t tnow;
long L;

FILE *fp;

/*
 * Get the current time
 */

time(&tnow);
tmnow = localtime(&tnow);

/*
 * Get the number of the last message entered, lock this file first
 */

mn = open("/ax25/mbx/system_files/last.msg",O_RDONLY);
lockf(mn,F_LOCK,0);
signal(SIGHUP,sig_ser);
read(mn,Temp,9);
lockf(mn,F_ULOCK,0);
signal(SIGHUP,SIG_DFL);
close(mn);
last = atoi(Temp);

/*
 * Create the name for the callers data base
 */

sprintf(filename,"/ax25/mbx/system_files/%s.data",argv[0]);

/*
 * If the data base exists greet the caller
 */

if ((fp = fopen(filename,"r+")) != NULL)
   {
   fscanf(fp,"%s %s",Temp,Date);
   fscanf(fp,"%s %s",Temp,Time);
   fseek(fp,65,SEEK_SET);
   fscanf(fp,"%s %s",Temp,List);
   fscanf(fp,"%s %s",Temp,Call);

/*
 * Here you can put something like   ...
 * L = atol(List);
 * printf("Last listed... %ld\n",L);
 * Last entered etc,
 * Last Login is shown as an example.
 *  
 * printf("Last login: %c%c-%c%c-19%c%c at %c%c:%c%c:%c%c\n",
 * Date[4],Date[5],Date[2],Date[3],Date[0],Date[1],Time[0],Time[1],
 * Time[2],Time[3],Time[4],Time[5]);
 */

   fseek(fp,0,SEEK_SET);
   fprintf(fp,"Date: %02d%02d%02d\n",
   tmnow->tm_year,(tmnow->tm_mon +1),tmnow->tm_mday);
   fprintf(fp,"Time: %02d%02d%02d\n",
   tmnow->tm_hour,tmnow->tm_min,tmnow->tm_sec);

   L = atol(Call);
   L++;
   if (L > 999999) L = 0;

   fseek(fp,78,SEEK_SET);
   fprintf(fp,"Call: %06ld\n",L);
   fclose(fp);
   }

/*
 * If the data base is not found, it is a first time user, so build one
 */

else
   {
   /* Create a data base for the new caller */
   if ((fp = fopen(filename,"w")) != NULL)
      {
      fprintf(fp,"Date: %02d%02d%02d\n",
      tmnow->tm_year,(tmnow->tm_mon +1),tmnow->tm_mday);
      fprintf(fp,"Time: %02d%02d%02d\n",
      tmnow->tm_hour,tmnow->tm_min,tmnow->tm_sec);
      fprintf(fp,"Sent: 000000\n");    /* Caller has sent no messages         */
      fprintf(fp,"Rcvd: 000000\n");    /* Caller has received no messages     */
      fprintf(fp,"Read: 000000\n");    /* Caller has read no messages         */
      fprintf(fp,"List: %06d\n",last); /* Set last listed to current msg      */
      fprintf(fp,"Call: 000001\n");    /* Caller has connect once (this time) */
      fprintf(fp,"Mail: 000000\n");    /* Caller has no personal mail waiting */
      fprintf(fp,"Srep: 000000\n");    /* Caller has nothing to reply to      */
      fprintf(fp,"Page: 000020\n");    /* Page set at 20 lines as default     */
      fclose(fp);
      }
   }
}

/*----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

